sope-ngobjweb(5)

NAME
sope-ngobjweb - Defaults for the libNGObjWeb library (part of SOPE)

DESCRIPTION
The sope-ngobjweb library implements the core web application server of SOPE. NGObjWeb provides a lot of defaults to configure operation and logging of SOPE based applications.

BUGS
SOPE related bugs are collected in the OpenGroupware.org Bugzilla:
  http://bugzilla.opengroupware.org/

Application Defaults
This section describes defaults which are related to general application setup.

-WOApplicationBaseURL url (empty)
    Select a different base URL. Do not touch this option unless you know what you are doing. It is overridden by the application URL set by mod_ngobjweb.

-WOApplicationSuffix suffix (.woa)
    The default selects the extension of the application wrapper. If you use a different application extension (eg .app), you need to properly configure this default.

-WOAutoOpenInBrowser YES|NO (NO)
    WOAutoOpenInBrowser is a WO compatibility default and does not do anything on non MacOSX platforms.

-WOCGIAdaptorURL url (empty)
    WOCGIAdaptorURL is a WO compatibility default and does not do anything in combination with SOPE. SOPE does not require those URLs because it is always in "direct connect mode".

-WOContactSNS YES|NO (NO)
    Whether the application should register with a snsd load balancing server.

-WOCoreOnApplicationException YES|NO (NO)
    If enabled, the application will call the system abort() function in case an uncatched exception occures. Abort will generate a coredump, so that you can analyze the cause for an exception. Only enable in development environments!

-WODebuggingEnabled YES|NO (NO)
    Enable NGObjWeb debug logs.

-WODefaultSessionTimeOut duration (3600)
    Use this option to set the default session timeout. The duration value is in specified seconds.

-WODefaultLanguages array-of-language-codes
    The language array specifies for what languages resource lookups are performed.

-WOExpirationTimeInterval seconds (120)
    Sets the interval in which session stores check whether sessions are expired and need to be shut down.

-WOFrameworksBaseURL url (/WebObjects/Frameworks)
    WOFrameworksBaseURL is a WO compatibility default and currently does not do anything in SOPE.

-WOGenerateMissingResourceLinks YES|NO (NO)
    If a resource (eg a filename in WOImage) could not be found, SOPE will generate a replacement URL.

-WOLogDefaultsOnStartup YES|NO (NO)
    When enabled, a SOPE will print all configured defaults to stdout on startup.

-WOLogPageCache YES|NO (NO)
    Print log messages when pages are stored or retrieved from the session page cache.

-WONoProxySuffixes array-of-strings (empty array)

-WOPageCacheSize number (30)

-WOPageRefreshOnBacktrack YES|NO (YES)

-WOPermanentPageCacheSize number (30)

-WOProjectSearchPath array-of-pathes (empty array)

-WOSMTPHost hostname (mail)

-WOSendMail path (/usr/lib/sendmail)

-WOSessionStore classname (WOServerSessionStore)

-WOStatsStylesheetName string (WOStats.xsl)

Component Defaults
This section describes component and template related defaults.

-WOCachingEnabled YES|NO (YES)
    If this default is enabled SOPE will cache all templates and won't check for changes. So you might want to disable caching during development but you definitely should leaved that enabled for deployments or get a huge performance hit.

-WOComponentExtensions array-of-exts ( (wo) )
    The option specifies what directory extensions will be treated as wrapper components extensions.

-WOComponentLoadWOOFiles YES|NO (NO)
    Component wrappers can contained serialized objects like datasources in so called .woo files. This options enables the loading of those serialized files at a minor speed hit.

-WOCompoundElementPool YES|NO (NO)
    Wrap each rendering of a compound template element in an NSAutoreleasePool. This can help to find memory bugs hidden in templates. You might also want to enable double release checks in the NSAutoreleasePool when using this option

-WOCoreOnAwakeComponentInCtxDealloc YES|NO (NO)
    This default can be used to debug situations where a context is being deallocated but a component is still awake. In such a situation the framework will trigger a coredump using abort() which can be used to investigate. Never enable in deployments!

-WOCoreOnRecursiveSubcomponents YES|NO (NO)
    When enabled, the framework will generate a coredump if a component makes a recursive call to itself. Note that this is not necessarily a bug.

-WODebugActions YES|NO (NO)

-WODebugComponentAwake YES|NO (NO)

-WODebugComponentDefinition YES|NO (NO)

-WODebugComponentLookup YES|NO (NO)

-WODebugCursor YES|NO (NO)

-WODebugKeyPathAssociation YES|NO (NO)

-WODebugResourceLookup YES|NO (NO)

-WODebugStaticLinkProcessing YES|NO (NO)

-WODebugTakeValues YES|NO (NO)

-WODescriptiveElementIDs YES|NO (NO)

-WOEnableComponentsWithoutClasses YES|NO (NO)
    When enabled SOPE will not print a warning if it finds a template but no matching Objective-C class or script.

-WOFormAlwaysPassDown YES|NO (YES)
    Disable this option if the WOForm dynamic element should only run the take values phase on its child elements if the form URI or element id matches the request. This might confuse dynamic elements which are not form elements but nevertheless want to take values from the request (like the DnD elements).

-WOLogComponents YES|NO (NO)
    When enabled, the WOContext will log when a component enters or leaves the component stack. This is useful to debug how components are activated.

-WONoSelectionString string (WONoSelectionString)
    The string to be used for empty selections in the WOPopUpButton dynamic element.

-WOParsersUseUTF8 YES|NO (NO)
    Only affects wrapper templates (XML templates use XML to specify the charset). When enabled, .html and .wod files will always be parsed in the UTF-8 encoding, otherwise the Foundation system (cstring) encoding will be used.

-WOResourceURLAssociationDebugEnabled YES|NO (NO)

-WOUseRelativeURLs YES|NO (YES)

-WOKeyPathAssociationsCacheSize number (200)

-WOValueAssociationsCacheSize number (200)

-WOxFileExtensions array-of-strings ( wox, xtmpl, xhtml )
    An array of the extensions for files which are to be loaded as WOx (XML based) templates.

-WOxElemBuilder_LogAssociationMapping YES|NO (NO)

-WOxElemBuilder_LogAssociationCreation YES|NO (NO)

-WOxComponentElemBuilderDebugEnabled YES|NO (NO)

-WOxLogBuilderQueue YES|NO (NO)

-WOxBuilderClasses - array-of-classnames

-WOxAssociationClassMapping - dict-of-uri-to-classnam

Request Handler Defaults

-WOComponentRequestHandlerKey string (wo)
    The name to be used in the URL for component request handler URLs (action binding URLs).

-WODirectActionRequestHandlerKey string (x)
    The name to be used in the URL for direct action request handler URLs. You may want to set this option to 'wa' for improved WO compatibility.

-WOResourceRequestHandlerKey string (y)
    The name to be used in the URL for resource request handler URLs.

-WOPageRequestHandlerDebugEnabled YES|NO (NO)
    Enable/disable debug logs in the page request handler.

SoObjects Defaults

-WOIsRedirectionEnabled YES|NO (NO)

-SoClassRegistryDebugEnabled YES|NO (NO)

-SoDebugKeyLookup YES|NO (NO)

-SoDebugTraversal YES|NO (NO)

-SoDebugProductLoading YES|NO (NO)

-SoDebugProductRegistry YES|NO (NO)

-SoDebugRequestClassification YES|NO (NO)

-SoLogSecurityDeclarations YES|NO (NO)

-SoOFSDebugFactory YES|NO (NO)

-SoOFSDebugPlistObject YES|NO (NO)

-SoOFSDebugRestore YES|NO (NO)

-SoOFSDebugNegotiate YES|NO (NO)

-SoOFSDebugAuthLookup YES|NO (NO)

-SoOFSWebMethodDebugEnabled YES|NO (NO)

-SoOFSResourceManagerDebugEnabled YES|NO (NO)

-SoObjCClassDebugEnabled YES|NO (NO)

-SoObjectSOAPDispatcherDebugEnabled YES|NO (NO)

-SoObjectDataSourceDebugEnabled YES|NO (NO)

-SoObjectRequestHandlerDebugEnabled YES|NO (NO)

-SoObjectMethodDispatcherDebugEnabled YES|NO (NO)

-SoPageInvocationDebugEnabled YES|NO (NO)

-SoProductResourceManagerDebugEnabled YES|NO (NO)

-SoRendererDebugEnabled YES|NO (NO)

-SoRedirectToDefaultMethods YES|NO (YES)

-SoSecurityManagerDebugEnabled YES|NO (NO)

-SoRequestDispatcherRules rules-array

XML-RPC Subsystem Defaults

-WOCoreOnXmlRpcFault YES|NO (NO)

-WOLogXmlRpcSelectorMapping YES|NO (NO)

-SoObjectXmlRpcDispatcherDebugEnabled YES|NO (NO)

WebDAV Subsystem Defaults

-SoObjectDAVDispatcherDebugEnabled YES|NO (NO)

-SoPreferredNamespacePrefixes dict-of-uri-to-name

-SoDefaultWebDAVPropertyNames array-of-fqn

-SoWebDAVFormatOutput YES|NO (NO)

-DAVParserDebugProp YES|NO (NO)

-SoWebDAVDefaultAllowMethods array-of-http-mehtods (GET, HEAD, ...)

-SoWebDAVDetectionMethods array-of-http-methods (OPTIONS,MKCOL, ...)

Adaptor Defaults
The NGObjWeb adaptor accepts requests from the outside and turns them into events in the SOPE application server. Do not mix up the NGObjWeb adaptor (which is a class inside the SOPE based server) with the mod_ngobjweb Apache module.

-WOAdaptor classname (WOHttpAdaptor)
    This argument selects the SOPE adaptor class used to receive requests from the outside. The only adaptor provided by SOPE itself is WOHttpAdaptor.

-WOAdaptorLogPath path (empty)
    Using this option you can select a path where all SOPE HTTP transactions are logged to.

-WOAdditionalAdaptors array-of-strings (empty)
    While -WOAdaptor selects the primary adaptor SOPE applications will receive input from, this option allows for any number of additional input ports.

-WOCoreOnHTTPAdaptorException YES|NO (NO)

-WODebugHttpTransaction YES|NO (NO)

-WODebugZipResponse YES|NO (NO)

-WODontZipResponse YES|NO (NO)
    In the default configuration SOPE compresses all responses if the browser supports that. Enable this option to disable compression which can be useful in combination with WOHttpAdaptor_LogStream.

-WOHttpAdaptorReceiveTimeout           = 120

-WOHttpAdaptorSendTimeout              = 120

-WOHttpAdaptor_LogStream YES|NO (NO)
    Log the complete HTTP transaction on stdout. You might also want to set WODontZipResponse to disable zip compression (otherwise you will only see

-WOHttpAllowHost hostname|array-of-hostnames (localhost)
    SOPE checks the IP of the client prior accepting a connection. Per default it only allows connects from localhost. In deployments you should always connect applications through Apache/mod_ngobjweb and keep the client restriction.

-WOHttpTransactionUseSimpleParser YES|NO (NO)
    Select whether the more complex/slow MIME parser or the new lightweight HTTP parser ('simple parser') should be used. The latter doesn't support all features required for HTML forms processing and should only be used for WebDAV and XML-RPC clients.

-WOIncludeCommentsInResponse YES|NO (YES)
    When disabled, HTML comments will be stripped from .html wrapper templates prior delivery to the client (WOx templates always strip comments). This might clash with JavaScript tags in your templates and is therefore enabled per default.

-WOListenQueueSize number (5)
    This parameter configures the backlog size of the socket listen queue. See the listen (2) call for further information.

-WOOutputValidationEnabled YES|NO (NO)

-WOPort number (20000)
    The port the SOPE application will listen on.

-WORunMultithreaded YES|NO (NO)
    Enable/disable multi threading in SOPE. Note that SOPE 4.5 is not considered thread safe.

-WOWorkerThreadCount number (0)
    Configures the number of worker threads which are used to receive/send requests and responses in parallel to the application processing. This is currently unsupported by the SOPE WOHttpAdaptor.

-WOSimpleHTTPParserDebugEnabled YES|NO (NO)

-WOSimpleHTTPParserFileIOBoundary number (16384)

-WOSimpleHTTPParserHeavyDebugEnabled YES|NO (NO)

-WOSimpleHTTPParserMaxUploadSizeInKB number (262144)

Profiling Defaults

-WOProfileApplication YES|NO (NO)

-WOProfileComponents YES|NO (NO)

-WOProfileDirectActionRequestHandler YES|NO (NO)

-WOProfileElements YES|NO (NO)

-WOProfileHttpAdaptor YES|NO (NO)

-WOProfileLoading YES|NO (NO)

-WOProfileResponse YES|NO (NO)

Deprecated Defaults

-WOLogScriptDealloc YES|NO (NO)

-WOLogScriptInit YES|NO (NO)

-WOLogScriptKVC YES|NO (NO)

AUTHOR
Helge Hess <helge.hess@opengroupware.org>

SEE ALSO
httpd(8), Defaults(5).